#!/usr/bin/env python3
# KeepeeUpee by Mike Cook

import RPi.GPIO as io
import time, random
from apa102bang import Apa102bang
stripLength = 8

def main():
  global beam,gameOn,ballHeight,ballCol
  print("Keepee Upee")
  init()
  gameOn = True
  ballDirection = -1; ballHeight = stripLength 
  foot = 0 ; kicks = 0
  currentGameSpeed = gameSpeed
  leds.setLed(0,footCol[foot]) # foot colour
  leds.show()
  time.sleep(gameSpeed)
  nextBallMove = time.time()+gameSpeed
  lastKickMade = not(io.input(kick))
  while 1:
    while gameOn:
      kickMade = not(io.input(kick))
      if kickMade and not(lastKickMade) :
        if ballHeight == 0: #   kick
           ballDirection = ballDirection * -1
           #speed up if you are late pressing
           if nextBallMove - time.time() < currentGameSpeed/2 :
             currentGameSpeed = currentGameSpeed / 2
           else:
             currentGameSpeed = gameSpeed
           nextBallMove = time.time()-1.0
           foot = 1
           kicks += 1 # add to your score
        else:
          foot = 2        
      if time.time()>nextBallMove:
         leds.setLed(ballHeight,(0,0,0))
         ballHeight +=ballDirection  
         leds.setLed(0,footCol[foot])
         leds.setLed(ballHeight,ballCol)         
         foot = 0
         nextBallMove = time.time()+currentGameSpeed
      if ballHeight >= stripLength-1 :
         ballDirection = -1
      if ballHeight < 0: #missed the ball
         gameOn = False
      lastKickMade = kickMade   
      leds.show()
    print("Ball missed your score",kicks)
    while not(io.input(kick)):
        pass
    time.sleep(gameSpeed* 5)         
    print("Press kick for a new game")
    while not(io.input(kick)):
        pass
    kicks = 0
    gameOn = True
    ballHeight = stripLength
    ballDirection = -1
    leds.show()
    currentGameSpeed = gameSpeed
    while io.input(kick):
        pass
  
def init():
   global kick,ball,leds,gameSpeed,footCol,ballCol
   random.seed()
   io.setmode(io.BCM)
   kick = 4
   io.setup(kick,io.IN, pull_up_down=io.PUD_UP)
   brightness = 4
   dataPin = 23 ; clockPin = 24 # Blinkit wiring
   leds = Apa102bang(stripLength,dataPin,clockPin,brightness)
   gameSpeed = 0.3 # step speed of game
   ballCol = (128,128,0)
   footCol = [(32,32,32),(128,0,0),(0,0,128)] # foot colours
        
# Main program logic:
if __name__ == '__main__':    
  try:
    main()
  except KeyboardInterrupt:
    pass
# turn off all LEDs  
leds.setAll((0,0,0))
leds.show() 

