#!/usr/bin/env python3
# Cubic clour space interpolate by Mike Cook

import time, random
from apa102bang import Apa102bang

def main():
  print("Cubic colour space interpolate")
  init()
  while 1:
     genCols()
     showBetween()
     time.sleep(1.5)
     strip.setAll((0,0,0)) # blank
     strip.show()
     time.sleep(0.5)
     
def showBetween():
   print()
   print("Cubic space from",c1,"to",c2)
   strip.setLed(0,c1)
   strip.setLed(7,c2)
   strip.show()
   time.sleep(0.5)
   redInc = float(c2[0] - c1[0])/6.0
   greenInc = float(c2[1] - c1[1])/6.0
   blueInc = float(c2[2] - c1[2])/6.0
   r = c1[0] ; g = c1[1] ; b = c1[2]
   for p in range(1,7):
      r += int(redInc)
      g += int(greenInc)
      b += int(blueInc)
      strip.setLed(p,(r,g,b))
      print(r,g,b)
      strip.show()
      time.sleep(0.6)
            
def genCols(): # Generate two different random colours
   global c1, c2
   while 1 :
     for c in range(0,2): 
        r = random.randint(0,5) * 51
        g = random.randint(0,5) * 51
        b = random.randint(0,5) * 51
        if c == 0:
           c1 = (r,g,b)
        else:
           c2 = (r,g,b)
     if c1 != c2 : # if they are not the same were done
        break
 
def init():
   global strip
   random.seed()
   length = 8 ; brightness = 4
   dataPin = 23 ; clockPin = 24 # Blinkt wiring
   strip = Apa102bang(length,dataPin,clockPin,brightness)
        
# Main program logic:
if __name__ == '__main__':    
    main()
